﻿Prio = LibStub("AceAddon-3.0"):NewAddon("Prio", "AceConsole-3.0", "AceEvent-3.0")
GTBLib = LibStub:GetLibrary("GTB-1.0")

function Prio:OnEnable()
    self:Print("Test")
end

local forward_time=12;
local reporttime;


function Prio:My_GetSpellNameById(spellId)
	if (spellId == nil) then
		return 
	end
	local spellName, _, _, _, _, _, _, _, _ = GetSpellInfo(spellId)
	return spellName
end

function Simple_ButtonClick()
DEFAULT_CHAT_FRAME:AddMessage(Simple_EditBox:GetText());
Simple_EditBox:SetText("");
end

function Simple_Close()
PrioFrame:Hide();
end

-- Katze
local SPELL_MANGLE_CAT = Prio:My_GetSpellNameById(33876)
local SPELL_RAKE = Prio:My_GetSpellNameById(59881)
local SPELL_FEARIE_FIRE_FERAL = Prio:My_GetSpellNameById(16857)
local SPELL_RIP = Prio:My_GetSpellNameById(49800)
local SPELL_BERSERK = Prio:My_GetSpellNameById(50334)
local SPELL_SAVAGE_ROAR = Prio:My_GetSpellNameById(52610)
local SPELL_TIGERS_FURY = Prio:My_GetSpellNameById(50213)
local SPELL_FEROCIOUS_BITE = Prio:My_GetSpellNameById(48577)
local SPELL_SHRED = Prio:My_GetSpellNameById(48572)
local SPELL_OOC = Prio:My_GetSpellNameById(16864)

local BUFF_MANGLE_CAT = Prio:My_GetSpellNameById(33876)
local BUFF_MANGLE_BEAR = Prio:My_GetSpellNameById(48654)
local BUFF_TRAUMA = Prio:My_GetSpellNameById(46855)
local BUFF_RAKE = Prio:My_GetSpellNameById(59881)
local BUFF_FEARIE_FIRE_FERAL = Prio:My_GetSpellNameById(16857)
local BUFF_FEARIE_FIRE = Prio:My_GetSpellNameById(770)
local BUFF_CURSE_WEAKNESS = Prio:My_GetSpellNameById(50511)
local BUFF_STING = Prio:My_GetSpellNameById(56631)
local BUFF_RIP = Prio:My_GetSpellNameById(49800)
local BUFF_BERSERK = Prio:My_GetSpellNameById(50334)
local BUFF_TIGERS_FURY = Prio:My_GetSpellNameById(50213)
local BUFF_SAVAGE_ROAR = Prio:My_GetSpellNameById(52610)
local BUFF_OOC = Prio:My_GetSpellNameById(16864)

-- Baer
local SPELL_DEMORALIZING_ROAR = Prio:My_GetSpellNameById(26998)
local SPELL_LACERATE = Prio:My_GetSpellNameById(48568)

local SPELL_MAUL = Prio:My_GetSpellNameById(48480)
local SPELL_SWIPE = Prio:My_GetSpellNameById(48562)
local SPELL_MANGLE_BEAR = Prio:My_GetSpellNameById(48564)

local BUFF_DEMORALIZING_ROAR = Prio:My_GetSpellNameById(26998)
-- local BUFF_LACERATE_5 = Prio:My_GetSpellNameById(48568)
local BUFF_LACERATE = Prio:My_GetSpellNameById(48568)


-- Krieger
local BUFF_DEMORALIZING_SHOUT = Prio:My_GetSpellNameById(47437)


local HEALTH = -2; -- "health";
local RAGE = 1; --"rage";
local MANA = 0; --"mana";
local ENERGY = 3; --"energy";
local COMBO = "combo";

local INF = 1000;
local GLOBAL = "global";

local buffs = {};
local dep = {}
local cooldown = {};

local time = 0;

local TIME = "time";
local COUNT = "count";

local ALL_dep ={};
ALL_dep["DRUID"] = {};
ALL_dep.DRUID["Cat"] = {};
ALL_dep.DRUID.Cat[BUFF_MANGLE_CAT] = { spell = BUFF_MANGLE_CAT; self = false}
ALL_dep.DRUID.Cat[BUFF_TRAUMA] = { spell = BUFF_MANGLE_CAT; self = false}
ALL_dep.DRUID.Cat[BUFF_MANGLE_BEAR] = { spell = BUFF_MANGLE_CAT; self = false}
ALL_dep.DRUID.Cat[BUFF_RAKE] = { spell = BUFF_RAKE; self = true}
ALL_dep.DRUID.Cat[BUFF_FEARIE_FIRE_FERAL] = {spell = BUFF_FEARIE_FIRE_FERAL; self = false}
ALL_dep.DRUID.Cat[BUFF_FEARIE_FIRE] = {spell = BUFF_FEARIE_FIRE_FERAL; self = false}
ALL_dep.DRUID.Cat[BUFF_CURSE_WEAKNESS] = {spell = BUFF_FEARIE_FIRE_FERAL; self = false}
ALL_dep.DRUID.Cat[BUFF_STING] = {spell = BUFF_FEARIE_FIRE_FERAL; self = false}
ALL_dep.DRUID.Cat[BUFF_RIP] = {spell = BUFF_RIP; self = true}
ALL_dep.DRUID.Cat[BUFF_BERSERK] = {spell = BUFF_BERSERK; self = true}
ALL_dep.DRUID.Cat[BUFF_TIGERS_FURY] = {spell = BUFF_TIGERS_FURY; self = true}
ALL_dep.DRUID.Cat[BUFF_SAVAGE_ROAR] = {spell = BUFF_SAVAGE_ROAR; self = true}
ALL_dep.DRUID.Cat[BUFF_OOC] = {spell = BUFF_OOC; self = true}

ALL_dep.DRUID["Bear"] = {};
ALL_dep.DRUID.Bear[BUFF_DEMORALIZING_ROAR] = {spell = BUFF_DEMORALIZING_ROAR; self = false}
ALL_dep.DRUID.Bear[BUFF_DEMORALIZING_SHOUT] = {spell = BUFF_DEMORALIZING_ROAR; self = false}
ALL_dep.DRUID.Bear[BUFF_CURSE_WEAKNESS] = {spell = BUFF_DEMORALIZING_ROARM; self = false}
ALL_dep.DRUID.Bear[BUFF_LACERATE] = {spell = BUFF_LACERATE; self = true}


local ALL_prio = {};
ALL_prio["DRUID"] = {};
ALL_prio.DRUID["Cat"] = {};
ALL_prio.DRUID.Cat[1] = { SPELL_FEARIE_FIRE_FERAL , { {BUFF_FEARIE_FIRE_FERAL,"<=", 0, TIME} } };
ALL_prio.DRUID.Cat[2] = { SPELL_TIGERS_FURY , { {ENERGY, "<=" , 40}, {BUFF_BERSERK, "<=", 0, TIME} } };
ALL_prio.DRUID.Cat[3] = { SPELL_BERSERK, { {ENERGY, ">=", 70}, {ENERGY, "<=", 90} } };
ALL_prio.DRUID.Cat[4] = { SPELL_SAVAGE_ROAR, { {COMBO, ">=", 1}, {BUFF_SAVAGE_ROAR, "<=", 1, TIME} } };
ALL_prio.DRUID.Cat[5] = { SPELL_SAVAGE_ROAR, { {COMBO, ">=", 5}, {BUFF_SAVAGE_ROAR, "<=", 6, TIME}, {BUFF_RIP, ">=", 6, TIME} } };
ALL_prio.DRUID.Cat[6] = { SPELL_RIP, { {COMBO, ">=", 5} } };
ALL_prio.DRUID.Cat[7] = { SPELL_FEROCIOUS_BITE, { {COMBO, ">=", 5}, {BUFF_RIP, ">=", 10, TIME} } };
ALL_prio.DRUID.Cat[8] = { SPELL_MANGLE_CAT, { {BUFF_MANGLE_CAT, "<=", 1, TIME} } };
ALL_prio.DRUID.Cat[9] = { SPELL_RAKE, { {BUFF_RAKE, "<=", 0, TIME} } };
ALL_prio.DRUID.Cat[10] = { SPELL_SHRED, { {ENERGY, ">=", 70, TIME} } };
ALL_prio.DRUID.Cat[11] = { SPELL_SHRED,  { {BUFF_OOC, ">", 0, TIME} } } ;
ALL_prio.DRUID.Cat[12] = { SPELL_SHRED, { {COMBO, "<=", 4}, {BUFF_RIP, "<=", 3, TIME} } };
ALL_prio.DRUID.Cat[13] = { SPELL_SHRED, { {BUFF_BERSERK, ">", 0, TIME} } };

ALL_prio.DRUID["Bear"] = {};
ALL_prio.DRUID.Bear[1] = { SPELL_DEMORALIZING_ROAR, { {BUFF_DEMORALIZING_ROAR, "<=", 0, TIME} }}
ALL_prio.DRUID.Bear[2] = { SPELL_FEARIE_FIRE_FERAL, { {BUFF_FEARIE_FIRE_FERAL, "<=", 0, TIME} }}
ALL_prio.DRUID.Bear[3] = { SPELL_MAUL, { {RAGE, ">=", 30} } }
ALL_prio.DRUID.Bear[4] = { SPELL_LACERATE, { {BUFF_LACERATE,"<",3,TIME} } }
ALL_prio.DRUID.Bear[5] = { SPELL_MANGLE_BEAR, {{}} }
ALL_prio.DRUID.Bear[6] = { SPELL_LACERATE, { {BUFF_LACERATE,"<",5,COUNT} } }
ALL_prio.DRUID.Bear[7] = { SPELL_FEARIE_FIRE_FERAL, {{}} }
ALL_prio.DRUID.Bear[8] = { SPELL_SWIPE, {{}} }


local prio = {};

local ALL_spamSpell = {};
ALL_spamSpell["DRUID"] = {};
ALL_spamSpell.DRUID[SPELL_MANGLE_CAT] = true;
ALL_spamSpell.DRUID[SPELL_SHRED] = true;
ALL_spamSpell.DRUID[SPELL_SWIPE] = true;
ALL_spamSpell.DRUID[SPELL_LACERATE] = true
  
local spamSpell = {};


local ALL_hasnogCD = {};
ALL_hasnogCD["DRUID"] = {}
ALL_hasnogCD.DRUID[SPELL_MAUL] = true;

local hasnogCD = {};

local ALL_notEffectedgCD = {};
ALL_notEffectedgCD["DRUID"] = {};
ALL_notEffectedgCD.DRUID[SPELL_MAUL] = true;

local notEffectedgCD = {};

local defaults = {
 char = {
   message = "TEST"
 }
};

local options = { 
    name = "Prio",
    handler = Prio,
    type = "group",
    args = {
        message = {
            type = "input",
            name = "Message",
            desc = "The message to be displayed when you get home.",
            usage = "<Your message>",
            get = "GetProperty",
            set = "SetProperty",
        },
    },
}

function Prio:GetProperty(info)
	local propName = info[#info];
	local value = self.db.char[propName];
	return value;
end

function Prio:SetProperty(info, newValue)
    local propName = info[#info];
	self.db.char[propName] = newValue;
end

function Prio:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(Prio, "prio", "Prio", input)
    end
end

local mainFrame

--local test = {}
--test[1] = {function(x) Prioend

function Prio:eval(spell,eq, value, type)
  if (not buffs[spell]) then
    if ((eq=="=" and value>0) or eq==">" or eq==">=") then return false;
    elseif (eq=="<" or eq=="=" or eq=="<=") then return true;
    end;
    return false;
  else
	local buff;
	if (type) then buff=buffs[spell][type];
		if (type==TIME) then buff = buff -time; end
		else buff = buffs[spell];
	end
	if eq=="=" then return buff==value;
	elseif eq==">" then return buff>value;
	elseif eq=="<" then return buff<value;
	elseif eq=="<=" then return buff<=value;
	elseif eq==">=" then return buff>=value;
	end;
  end;
  return false;
end

local window = {};

function Prio:OnInitialize()
    -- Wird aufgerufen, wenn das AddOn geladen wird.
    self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    self:RegisterEvent("UNIT_AURA");
    self:RegisterEvent("PLAYER_TARGET_CHANGED");
    self:Print("Test1");
	
	self.db = LibStub("AceDB-3.0"):New("PrioDB", defaults, "char")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Prio", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Prio", "Prio")
    self:RegisterChatCommand("prio", "ChatCommand")
    self:RegisterChatCommand("Prio", "ChatCommand")
    self.db:RegisterDefaults(defaults);
       
    self:Print("loading Profile");
    Prio:loadProfile("DRUID","Bear");
    self:Print("Profile loaded");

    reporttime = GetTime();
    
    window = GTBLib:RegisterGroup("timers", "Interface\\Addons\\Prio\\default")
    window:EnableGradient(false);
    
--    self:Print(BUFF_MANGLE_CAT .. SPELL_MANGLE_CAT);
end

function Prio:COMBAT_LOG_EVENT_UNFILTERED(...)
  -- Das wird halt andauern gemacht hier, momentan bei jedem Combatlogevent, muss man mal schaun...
  -- self:Print("cle");
 -- self:Print(test[1](SPELL_FEARIE_FIRE_FERAL,0));
  local event, guid = select(3, ...);
  
  if (	(
		(event=="SPELL_AURA_APPLIED" or
		event=="SPELL_AURA_REMOVED" or
		event=="SPELL_AURA_APPLIED_DOSE" or
		event=="SPELL_AURA_REMOVED_DOSE" or
		event=="SPELL_AURA_BROKEN" or
		event=="SPELL_AURA_REFRESH" or
		event=="SPELL_AURA_BROKEN_SPELL")
		and
		(guid == UnitGUID("player") or 
		 guid== UnitGUID("target") ) 
		)
		or
		(
		(event=="SPELL_CAST_START" or
		event=="SPELL_CASE_SUCCESS" or
		event=="SPELL_ENERGIZE" or
		event=="SPELL_DRAIN" or
		event=="SPELL_PERIODIC_ENERGIZE" or
		event=="SPELL_PERIODIC_DRAIN" ) 
		and
		(guid == UnitGUID("player"))
		)
	  )	
  then
	index = 0;
	buffs = Prio:Get_Buffs();
	cooldown = {};
	time = GetTime();
	end_time = forward_time+GetTime();
	queue = {};
	repeat
		next_spell = Prio:Get_MaxPrio(buffs, time);
		buffs, time = Prio:Apply_Spell(next_spell); 
	-- if (next_spell) then Prio:Add_Queue(next_spell,index,time); end;
	until (time >= end_time)
	Prio:Report_Spells(queue);
 -- elseif (guid==UnitGUID("player")) then self:Print(event .. guid .. UnitGUID("player"));
  end
end

function Prio:UNIT_SPELLCAST_SUCCEEDED(unit, spell)
	self:print("test");
	if (unit=="player") then
		self:print("unitspellcastsucceeded");
		window:UnregisterBar(spell);
	end	
end

function Prio:loadProfile(class,prof)
	dep = ALL_dep[class][prof];
	prio = ALL_prio[class][prof];
	spamSpell = ALL_spamSpell[class];
	hasnogCD = ALL_hasnogCD[class];
	notEffectedgCD = ALL_notEffectedgCD[class];
end

function Prio:CheckCooldown(spell, time)
	--if (spell==SPELL_FEARIE_FIRE_FERAL) then self:Print(GetSpellCooldown(spell)) end
	if (not cooldown[spell]) then 
		local start, dur = GetSpellCooldown(spell); 
		if (start) then cooldown[spell]= start + dur end;
	end;		
	if (not cooldown[spell]) then return true; end;
	if cooldown[spell]<time then return true; end;
	return false;
end

function Prio:CheckGlobalCooldown(spell, time)
	if (notEffectedgCD[spell]) then return true;
	elseif (not cooldown[GLOBAL]) then return true;
	else return (cooldown[GLOBAL]<time) end;
end

--TODO: Momentan wird zum Schluss überprüft, ob genug Energie vorhanden ist, um den Spruch zu wirken, wenn nicht, mach gar nichts.
-- Das ist bei Katzen/Schurken auch sinnvoll, bei Wut allerdings uU nicht, da zB der Bär auch Sprüche hat, die KEINE Wut kosten, die
-- könnte man in solchen Fällen natürluich trotzdem wirken.

function Prio:Get_MaxPrio(b, time)
	-- Spruch mit der hoechsten Prioritaet abhaengig der Buffs herausfinden
--	if ( Prio:CheckCooldown(SPELL_FEARIE_FIRE_FERAL,time) and (not b[SPELL_FEARIE_FIRE_FERAL] or b[SPELL_FEARIE_FIRE_FERAL]<time)) then return SPELL_FEARIE_FIRE_FERAL;
--	elseif  ((not b[SPELL_RAKE]) or (b[SPELL_RAKE]<time)) then return SPELL_RAKE
--	elseif (not b[SPELL_MANGLE_CAT]) or (b[SPELL_MANGLE_CAT]<time) then return SPELL_MANGLE_CAT; end
	local i=1;
	local foundSpell = false
	local spell = "";
	while (prio[i]) and (not foundSpell)
	do
		spell = prio[i][1];
		-- self:Print(spell);
		local conditions = prio[i][2];
		foundSpell = true;
		for k,c in pairs(conditions) do
			if (c[1]) then 
				--self:Print(c[1] .. " " .. c[2] .. " " .. c[3]);
				--self:Print(Prio:eval(c[1],c[2],c[3],c[4]));
				foundSpell = foundSpell and Prio:eval(c[1],c[2],c[3],c[4]); end;
			-- self:Print(spell)
			--self:Print(c[1] .. c[2] .. c[3]);
			--self:Print(Prio:eval(c));
		end
		foundSpell = foundSpell and Prio:CheckCooldown(spell, time);
		i = i + 1;	
	end
	if (not prio[i-1]) then return nil end;
	foundSpell = foundSpell and Prio:CheckEnergy(spell);
   	if foundSpell then return spell end;
end

function Prio:CheckEnergy(spell)
	-- self:Print(spell);
	if not spell then return false; end;
	local _, _, _, cost, _, powerType = GetSpellInfo(spell);
	if (cost) then return (buffs[powerType] > cost); end;
	return true;
end


function Prio:Add_Queue(next_spell, i, time)
	-- Spruch an Ausgabeliste anfuegen
   queue[i] = {next_spell, time};
   -- self:Print("Queue " .. next_spell .. " " ..time);
end

function Prio:GetSpellForBuff(buffs)
	-- Spruchname zuordnen, der zu einem Buff/Debuff gehoert
	return
end

-- Energie
function Prio:Get_Buffs()
	-- Welche Debuffs sind auf dem Boss, welche Buffs auf mir? Und hab ich sie selber gewirkt oder war das wer anderes?
	buffs = {}
	for k=1,40 do 
		local name, _, _, count, _, duration, expirationTime, unitCaster, _, _, _ = UnitDebuff("target",k);
		--self:Print("Buffs" .. k);
		-- if name then self:Print(name .. expirationTime); end;
		--self:Print(dep[name]);
		if (dep[name]) then
			--self:Print("Buffs" .. name);
			if	( not (dep[name].self) or (unitCaster=="player") ) then
				--self:Print("GetBuffs: " .. name);
				buffs[dep[name].spell] = {};
				buffs[dep[name].spell][TIME] = expirationTime;
				buffs[dep[name].spell][COUNT] = count;
			end
		end
	end
	for k=1,40 do 
		name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId 
 = UnitBuff("player",k) 
		if  (dep[name]) then
			if	( not (dep[name].self) or (unitCaster=="player") ) then
				buffs[dep[name].spell]={};
				buffs[dep[name].spell][TIME] = expirationTime;
				buffs[dep[name].spell][COUNT] = count;
			end
		end
	end
	buffs[COMBO] = GetComboPoints("player", "target");
	buffs[ENERGY] = UnitPower("player",3);
	buffs[RAGE] = UnitPower("player",1);
	buffs[MANA] = UnitPower("player",0);
	buffs[HEALTH] = UnitPower("player",-2);
	return buffs;
end

function Prio:getInstantLength()
  return 1.5;
end


function Prio:getCombo(spell)
  return 1;
end


-- Berserk, Savage Roar, Energiekosten, Energiekosten bei Berserk
function Prio:Apply_Spell(spell)
	-- Was hätte der Spruch für Auswirkungen?
	if (spell) then
		-- self:Print(spell);
		index = index + 1;
		Prio:Add_Queue(spell,index,time); 
		-- local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spell);
		local _, _, _, cost, _, powerType, castTime  = GetSpellInfo(spell);
		-- self:Print(spell .. castTime);
		if ( (spell==SPELL_RAKE) or (spell==SPELL_MANGLE_CAT) or (spell==SPELL_SHRED)) then buffs[COMBO] = buffs[COMBO] + Prio:getCombo(spell);
		elseif ( (spell==SPELL_RIP) or (spell==SPELL_SAVAGE_ROAR) or (spell==SPELL_FEROCIOUS_BITE) ) then buffs[COMBO] = 0;
		end;
		
		if ( spell==TIGERS_FURY ) then buffs[ENERGY] = buffs[ENERGY] + 30; end;
		
		if ( spell==SHRED ) then end; -- SHREDGLYPHE!!
		
		-- self:Print(spell);
		if (powerType) then
			if (cost) then buffs[powerType] = buffs[powerType] - cost; end;
		end
		
		if (not buffs[spell]) then buffs[spell] = {}; end;
		buffs[spell][TIME] = time + INF;
		if (not buffs[spell][COUNT]) then buffs[spell][COUNT] = 0; end;
		buffs[spell][COUNT] = buffs[spell][COUNT] + 1;
		
		if (not spamSpell[spell]) then cooldown[spell] = time + INF; end;
									
		
		
		-- self:Print(castTime)
		if (not castTime or castTime==0) 
			then if (not hasnogCD[spell]) then cooldown[GLOBAL] = time + Prio:getInstantLength(); time = time + Prio:getInstantLength() end
		else time = time + castTime;
	    end
	else time = time + 0.1; buffs[ENERGY] = buffs[ENERGY] + 1;
	end;
	return buffs, time;
end


local registeredSpells = {};

function Prio:Report_Spells(queue)
	--if (GetTime()>reporttime) then
	--window:UnregisterAllBars()
	for i,v in pairs(queue) do
		if (v[1]) then 
			local _, _, icon =GetSpellInfo(v[1])
			window:RegisterBar(v[1], v[1], math.max(v[2]-GetTime(),0) , forward_time , icon)
			registeredSpells[#registeredSpells + 1] = v[1];
			--self:Print(i .. " " .. v[1] .. " in " .. v[2]-GetTime()) end;
		end
	end
	for i,v in pairs(registeredSpells) do
		local b = false;
		for j,w in pairs(queue) do
			--self:Print(w[1] .. v);
			if (w[1] == v) then b = true; end;
		end
		if (not b) then window:UnregisterBar(v, true) end;
	end
end


function Prio:PLAYER_TARGET_CHANGED(...)
    buffs = Prio:Get_Buffs();
end

function Prio:UNIT_AURA(unitID)
    if ((unitID=="player") or (unitID=="target")) then buffs = Prio:Get_Buffs(); end
end